#include <LCD.h>
#include <LiquidCrystal_I2C.h>
#include <stdlib.h>

#define I2C_ADDR    0x27  // LCD
#define BACKLIGHT_PIN     3
#define buttonOff  8
#define buttonNext 9

#define En_pin  2
#define Rw_pin  1
#define Rs_pin  0
#define D4_pin  4
#define D5_pin  5
#define D6_pin  6
#define D7_pin  7

int lcd_page = 1;            // start page on LCD
int lcdButtonState = 0;      // variable for reading the pushbutton status
bool lcdButtonOldS = 0;      // pushbutton old state
bool buttonOffState;         // pushbutton "off" state
bool buttonOffStateOld = 0;  // pushbutton old off state
bool lcdState = true;        // LCD state (on / off)

char disp[5];  

LiquidCrystal_I2C  lcd(I2C_ADDR,En_pin,Rw_pin,Rs_pin,D4_pin,D5_pin,D6_pin,D7_pin);

void setup() {
  lcd.begin (20,4);
  lcd.setBacklightPin(BACKLIGHT_PIN,POSITIVE);  // backlight on default
  lcd.setBacklight(HIGH);
  lcd.home ();                   // go home
  pinMode(buttonOff, INPUT);
  pinMode(buttonNext, INPUT);
}

void loop() {
// ***************************** LCD on / off **********************************

buttonOffState = digitalRead(buttonOff);
if ((buttonOffState == true) & (buttonOffStateOld == false)) {
  lcdState = !lcdState;
  if (lcdState) {
    lcd_page = 1;
    lcd.display();
    lcd.clear();
    lcd.setBacklightPin(BACKLIGHT_PIN,POSITIVE);  // backlight on default
    lcd.setBacklight(1);
  }
  else {
    lcd.noDisplay();
    lcd.setBacklightPin(BACKLIGHT_PIN,NEGATIVE);  // backlight on default
    lcd.setBacklight(0);
  }
}

buttonOffStateOld = buttonOffState;
// ***************************** LCD *******************************************    lcdButtonState = digitalRead(buttonNext);
  lcd.setBacklight(1);          // Backlight event 
  
  lcdButtonState = digitalRead(buttonNext);
  if (lcdButtonState == HIGH) {
    if (lcdButtonOldS == 0) {
      ++lcd_page; 
      page_clear();
      if (lcd_page > 3) {
        lcd_page = 1;
      }
    }
    lcdButtonOldS = 1;    // button old state   
  }
  else {
    lcdButtonOldS = 0;    // button old state
  }

  switch (lcd_page) {     // valid page
    case 1: page_1();break;     // call page 1
    case 2: page_2();break;     // call page 2
    case 3: page_3();break;     // call page 3
    }

}


void page_1 ()
{
  lcd.home ();
  lcd.setCursor ( 0, 0 );        // 1st line  
//                     1         2
//           012345678901234567890
  lcd.print("OB121.com    Page 1 ");  
  lcd.setCursor ( 0, 1 );        // go to the 2nd line
  lcd.print(" ");
  lcd.setCursor ( 0, 2 );        // go to the third line
  lcd.print(" ");
  lcd.setCursor ( 0, 3 );        // go to the fourth line
  lcd.print("  ");
}  

void page_2 ()
{
  lcd.home ();
  lcd.setCursor ( 0, 0 );        // 1st line  
//                     1         2
//           012345678901234567890
  lcd.print("OB121.com    Page 2 ");  
  lcd.setCursor ( 0, 1 );        // go to the 2nd line
  lcd.print(" ");
  lcd.setCursor ( 0, 2 );        // go to the third line
  lcd.print(" ");
  lcd.setCursor ( 0, 3 );        // go to the fourth line
  lcd.print("  ");
} 

void page_3 ()
{
  lcd.home ();
  lcd.setCursor ( 0, 0 );        // 1st line  
//                     1         2
//           012345678901234567890
  lcd.print("OB121.com    Page 3 ");  
  lcd.setCursor ( 0, 1 );        // go to the 2nd line
  lcd.print(" ");
  lcd.setCursor ( 0, 2 );        // go to the third line
  lcd.print(" ");
  lcd.setCursor ( 0, 3 );        // go to the fourth line
  lcd.print("  ");
} 

void page_clear ()
{
  lcd.home ();
  lcd.setCursor ( 0, 0 );        // 1st line  
//                     1         2
//           012345678901234567890
  lcd.print("                     ");  
  lcd.setCursor ( 0, 1 );        // go to the 2nd line
  lcd.print("                     ");
  lcd.setCursor ( 0, 2 );        // go to the third line
  lcd.print("                     ");
  lcd.setCursor ( 0, 3 );        // go to the fourth line
  lcd.print("                     ");
} 
